<script lang="ts">
	import type { FeatureGroup, GeoJSON, LeafletEvent, Map, Marker } from 'leaflet';
	import markerIcon2x from 'leaflet/dist/images/marker-icon-2x.png';
	import markerIcon from 'leaflet/dist/images/marker-icon.png';
	import markerShadow from 'leaflet/dist/images/marker-shadow.png';
	import 'leaflet/dist/leaflet.css';
	import { onMount } from 'svelte';
	import mapData from './map.json';

	let map: Map;
	let mapElement: HTMLElement;
	let geoJsonLayer: GeoJSON<any, GeoJSON.Geometry>;

	let lc: any;
	export const geolocate = () => {
		lc.start();
	};

	let highlightedRoom: Marker | undefined;

	export let tryHighlightRoom: ((location: string) => boolean) | undefined;

	onMount(async () => {
		if (import.meta.env.VITEST) return;
		const Leaflet = await import('leaflet');
		const LeafletLocateControl = await import('leaflet.locatecontrol');

		Leaflet.Icon.Default.imagePath = '';
		Leaflet.Icon.Default.prototype.options.iconUrl = markerIcon;
		Leaflet.Icon.Default.prototype.options.iconRetinaUrl = markerIcon2x;
		Leaflet.Icon.Default.prototype.options.shadowUrl = markerShadow;

		const highlightedIcon = new Leaflet.Icon.Default({ className: 'leaflet-highlighted-room' });

		tryHighlightRoom = (room: string): boolean => {
			const roomLayer = geoJsonLayer.getLayers().find((layer: any) => {
				return layer.feature?.properties?.name === room;
			}) as FeatureGroup;

			if (!roomLayer) return false;

			const center = roomLayer.getBounds().getCenter();

			if (highlightedRoom) {
				map.removeLayer(highlightedRoom);
			}

			highlightedRoom = Leaflet.marker(center, {
				icon: highlightedIcon,
				title: 'highlighted room'
			}).addTo(map);
			if (!map.getBounds().contains(center)) {
				map.panTo(center, { animate: true, duration: 1 });
			}
			return true;
		};

		map = Leaflet.map(mapElement, {
			maxZoom: 22,
			zoomSnap: 0.2
		});

		const oldBoundaries = [
			[53.00094, 9.85899],
			[53.00236, 9.86071]
		];

		const boundariesToUse = oldBoundaries;

		map.fitBounds(Leaflet.latLngBounds(boundariesToUse));

		const CustomLocateControl = (Leaflet.Control as any).Locate.extend({
			_drawMarker: function () {
				(Leaflet.Control as any).Locate.prototype._drawMarker.apply(this, arguments);
			}
		});
		lc = new CustomLocateControl({
			createButtonCallback: () => ({
				link: document.createElement('a'),
				icon: document.createElement('img')
			})
		}).addTo(map);

		Leaflet.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
			attribution:
				'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors',
			maxZoom: 22,
			minZoom: 0,
			maxNativeZoom: 19
		}).addTo(map);

		geoJsonLayer = Leaflet.geoJson(mapData as any, {
			onEachFeature: (feature, layer: FeatureGroup) => {
				if (feature.properties?.amenity === 'cafe') {
					layer.setStyle({
						fillColor: /* brown */ '#A52A2A',
						color: /* brown */ '#A52A2A'
					});
				} else if (feature.properties?.amenity === 'restaurant') {
					layer.setStyle({
						fillColor: /* light green */ '#90EE90',
						color: /* light green */ '#90EE90'
					});
				} else if (feature.properties?.amenity === 'toilets') {
					layer.setStyle({
						fillColor: /* blue */ '#3388ff',
						color: /* blue */ '#3388ff'
					});
				} else if (layer.setStyle) {
					layer.setStyle({
						fillColor: /* light blue */ '#ADD8E6',
						color: /* light blue */ '#ADD8E6'
					});
				}

				if (feature.properties.name) {
					const tooltip = Leaflet.tooltip({
						content: feature.properties.name,
						permanent: true,
						interactive: true,
						direction: 'center',
						className: 'roomNameToolip'
					});
					layer.bindTooltip(tooltip);
					if (feature.properties.description) {
						tooltip.options.className += ' clickable';
						tooltip.bindPopup(feature.properties.description);
					}
				}
			}
		}).addTo(map);

		const co2Layer = Leaflet.geoJSON(undefined, {
			onEachFeature: (feature, layer: FeatureGroup) => {
				const tooltip = Leaflet.tooltip({
					content: `${feature.properties.co2}ppm CO²`,
					permanent: true,
					direction: 'center',
					className: 'co2Tooltip'
				});
				layer.bindTooltip(tooltip);
			}
		}).addTo(map);

		let co2timer: ReturnType<typeof setTimeout> | undefined;
		const updateCo2 = async () => {
			const response = await fetch('https://airquality.k8s.with-humans.org/sensors');
			const data = await response.json();

			co2Layer.clearLayers();
			co2Layer.addData({
				...data,
				features: data.features.filter((feature) => {
					if (!feature.properties?.timestamp) return false;
					return new Date().getTime() / 1000 - feature.properties?.timestamp < 60 * 5;
				})
			});

			co2timer = setTimeout(updateCo2, 5000);
		};
		updateCo2();

		const updateFontSize = (e: LeafletEvent) => {
			const zoomLevel = e.target?._animateToZoom || map.getZoom();
			mapElement.style.setProperty('--leaflet-tooltip-zoomed-font-scale', String(zoomLevel / 20));
		};
		map.on('zoomstart', updateFontSize);

		return {
			destroy() {
				clearTimeout(co2timer);
				map.remove();
			}
		};
	});
</script>

<div id="map" bind:this={mapElement} style="width: 100%; height: 100%; z-index: 0" />

<style lang="scss">
	:global(.leaflet-tooltip) {
		font-size: calc(12px * var(--leaflet-tooltip-zoomed-font-scale));
		transition: font-size 250ms;
	}
	:global(.roomNameToolip, .co2Tooltip) {
		background: none;
		border-radius: unset;
		border: unset;
		text-shadow:
			-1px -1px 0 #ccc,
			1px -1px 0 #ccc,
			-1px 1px 0 #ccc,
			1px 1px 0 #ccc;

		box-shadow: unset;
		min-width: 150px;
		white-space: normal;
		overflow-wrap: break-word;
		text-align: center;
	}
	:global(.leaflet-highlighted-room) {
		filter: hue-rotate(145deg);
	}

	:global(.clickable) {
		text-decoration: underline;
	}

	:global(.clickable:hover, .clickable:focus-within) {
		text-decoration: none;
	}
</style>
